%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
struct s_date { int year ; int mo ; int day; } ;
struct s_span { struct s_date start ; struct s_date end ; } ;
const int days_in_month[13] = { 0,31,29,31,30,31,30,31,31,30,31,30,31 } ;
const char * MonStr[13] = { NULL,"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"} ;
const char * monStr[13] = { NULL,"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"} ;
int year ;
%}

%union{
int tint ;
char * tchar ;
struct s_date ts_date ;
struct s_span ts_span ;
}

%token <tint> DAY MONTH YEAR EOL
%token <tchar> TEXT
%type <ts_date> date
%type <tchar> form1 form2
%right <tchar> OOA OOB DAYSPEC

%%
input :	/* empty */
	| input form1
	| input form2
	| input pcal47
;



form2 : DAYSPEC OOA date OOB date TEXT EOL
	{
		void loopdate(char *,struct s_date , struct s_date , char *) ;
		loopdate($1,$3,$5,$6) ;
	}

form1 :	OOA date OOB date TEXT EOL
	{
		void loopdate(char *,struct s_date , struct s_date , char *) ;
		loopdate("",$2,$4,$5) ;
	}
;

date : MONTH DAY
	{ struct s_date thisday ;
	  thisday.year = year ;
	  thisday.mo = $1 ;
	  thisday.day = $2 ;
	  $$ = thisday ;
	}
;

pcal47 : TEXT EOL
	{ printf("%s\n",$1) ; }
	| YEAR
	{ printf("year %d\n",$1) ; year=$1 ; }
	| EOL
	{ printf("\n") ; }
;

%%
/******************************************************
 Return non-zero if the date "one" is equal to or before the date "two"
*************************************************************/
static int is_befo( const struct s_date one, const struct s_date two)
{
	if ( one.year < two.year )
		return 1 ;
	else if ( one.year > two.year )
		return 0 ;
	else if (one.mo < two.mo)
		return 1 ;
	else if (one.mo > two.mo)
		return 0 ;
	else if (one.day <= two.day)
		return 1 ;
	else
		return 0 ;
}
void loopdate(char *dayspec,struct s_date s_start, struct s_date s_stop, char *text)
{
	struct s_span interval ;
	int crossyear=0 ;

	interval.start = s_start ;
	interval.end = s_stop ;
	interval.start.year = year ;
			/* may cross December to January */
	if( interval.start.mo > interval.end.mo
		|| interval.start.mo == interval.end.mo && interval.start.day > interval.end.day )
	{
		interval.end.year = interval.start.year +1 ;
	}
	else
	{
		interval.end.year = interval.start.year ;
	}
	while ( is_befo(interval.start,interval.end) )
	{
		printf("%s %s %d %s\n",dayspec,MonStr[interval.start.mo], interval.start.day, text ) ;
		interval.start.day ++ ;
		if( interval.start.day > days_in_month[interval.start.mo] )
		{
			interval.start.day = 1 ;
			interval.start.mo++ ;
			if ( interval.start.mo > 12 )
			{
				interval.start.mo = 1 ;
				interval.start.year ++ ;
				printf("year %d\n",interval.start.year) ;
				crossyear++ ;
			}
		}
	}
	if ( crossyear )
		printf("year %d\n",interval.start.year-crossyear) ;
}
int yyerror(char *s)
{
	printf("%s\n",s) ;
}
int main(int argc, char *argv[])
{
	/* yydebug= 1 ; */
	yyparse() ;
	return 0 ;
}
